#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <unistd.h>
#include <errno.h>
#include <stdio.h>
#include "net.h"
#include "rpmpldi.h"

#define INFO(a) printf a

int inet_connect(const char *host, int port)
{
    	char pbuf[sizeof("65536\0")];
	char hbuf[NI_MAXHOST];
	struct addrinfo hints, *res, *res0;
	int sock = -1;
	int gerr;

	snprintf(pbuf, sizeof(pbuf), "%d", port);
	memset(&hints, 0, sizeof(hints));
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;
	gerr = getaddrinfo(host, pbuf, &hints, &res0);
	if (gerr) {
	    fprintf(stderr, "resolv error %s: %s\n",
		    host, gai_strerror(gerr));
	    return -1;
	}

	for (res = res0; res; res = res->ai_next) {
	    sock = socket(res->ai_family, res->ai_socktype, res->ai_protocol);
	    if (sock == -1) {
		if (res->ai_next)
		    continue;
		else {
		    perror(_("socket"));
		    goto shit;
		}
	    }

	    if (getnameinfo(res->ai_addr, res->ai_addrlen, hbuf, sizeof(hbuf),
			NULL, 0, NI_NUMERICHOST))
		INFO((_("connecting to [%s]...\n"), hbuf));
	    else
		INFO((_("connecting...\n")));
	    
	    if (connect(sock, res->ai_addr, res->ai_addrlen)) {
		if (res->ai_next) {
		    close(sock);
		    continue;
		} else {
		    perror(_("connect"));
		    goto shit;
		}
	    }
	    break;
	}
	freeaddrinfo(res0);
	
	return sock;

shit:
	freeaddrinfo(res0);
	close(sock);
	return -1;
}
